/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package vostokiolibsample;

import org.vostok.lang.Entry;
import org.vostok.lang.PriorityList;

/**
 *
 * @author levreau.jerome@vostoksystem.eu
 */
public class TestPriorityList {

	PriorityList list;

	public TestPriorityList() {
		System.out.println("\n-->  create priority list for type String ");

		list = new PriorityList();
		for (int i = 1; i <= 20; i++) {
			list.add(new Entry(Integer.toString(i), Integer.toString(i)));
		}
	}

	/**
	 * @param args the command line arguments
	 */
	public static void main(String[] args) {
		System.out.println("\n\n----------------  Priority list ------------------");


		TestPriorityList t = new TestPriorityList();
		t.dumpList();
		t.recherche("18");
		t.dumpList();
		t.recherche("89");
		t.recherche("18");
		t.dumpList();
		t.remove("6");
		t.dumpList();
	}

	public void dumpList() {
		System.out.println("\n-->  state of the list, length : " + list.size());

		for (Entry e : list) {
			System.out.print(e.getKey() + " ");
		}
		System.out.println("");
	}

	public void recherche(String key) {
		System.out.println("\n --> search for " + key);

		System.out.println("recherche " + key);
		if (list.find(key) != null) {
			System.out.println("# found en entry for " + key + " at index " + list.findPosition(key));
		} else {
			System.out.println("# no entry found for " + key);
		}
	}

	public void remove(String key) {
		System.out.println("\n-->  remove from the list entry with key :" + key);

		list.removeByKey(key);
	}
}
